/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: in 20 Minutes (Coffee Break Series)
	 Beginners Taste

     Minimal working examples (MWE) to build upon and 
	 modify to gain an understanding of the API

	 Extensions to the Vulkan Graphics Coffee Break Series
	   
/*
/****************************************************************/


#version 420


layout (binding = 1) uniform sampler2D shadowMapTex;

layout (location = 0) in vec4 inCPosition;
layout (location = 1) in vec4 inLPosition;
layout (location = 2) in vec3 inNormal;


layout (location = 0) out vec4 outFragColor;



void main() 
{										
	//vec4 abc = inLPosition*0.5 + vec4(0.5,0.5,0.5,0); 
	vec4 ProjectionCoords = inLPosition / inLPosition.w; 
	vec2 UVCoords;								
	//UVCoords = ProjectionCoords.xy;// * 1.0 + vec2(0.05,0.05);	
	UVCoords.x = 0.5 * ProjectionCoords.x + 0.5;
	UVCoords.y = 0.5 * ProjectionCoords.y + 0.5; 
	float depth = texture( shadowMapTex, UVCoords.st ).z;
	float shadow = 1.0;							
	ProjectionCoords.z += 0.0001;				
	if ( inLPosition.w > 0 )					
	if ( depth < ProjectionCoords.z )			
		shadow = 0.5;							
	outFragColor = vec4(0, 1, 0, 1) * shadow;		
	float diff = 0.4 + dot(inNormal, vec3(-0.1,0.9,0));
	outFragColor *= diff;							
	outFragColor.a = 1.0;							
}